//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
#include <iostream>

#using <mscorlib.dll>
using namespace System;

struct UnmanagedException
{
	UnmanagedException(int e) : err(e)
	{
	}
	int Error()
	{
		return err;
	}
private:
	int err;
};

void ExceptionGenerator(int i)
{
   if (i == 0)
   {
	   // Throw an exception that is not based on
	   // System.Exception so it is an unmanaged exception
	   UnmanagedException *e = new UnmanagedException(10);
	   throw (e);
   }
   else if(i == 1)
   {
	   // Managed exception
	   Exception *e = new Exception;
	   throw e;
   }
   else if(i == 2)
   {
	   // Divide by zero
	   int a = 0;
	   int b = 1;
	   int c = b/a;
   }
   else if(i == 3)
   {
	   // Null Reference
	   int *pint = 0;
	   std::cout << pint[10] << std::endl;
   }
   else if(i == 4)
   {
	   // StackOverflow
	   ExceptionGenerator(4);
   }
   else if(i == 5)
   {
	   // Unspecified
	   throw;
   }
}

void FilterTest()
{
	for (int i = 0; i < 1; i++)
	{
		__try
		{
			throw new InvalidOperationException("This is a test");
		}
		__except (i == 0)
		{
			Console::WriteLine(S"\nCaught i==0 exception\n");
		}
	}
}

int main()
{
	for (int i = 0; i < 6; i++)
	{
		try
		{
			ExceptionGenerator(i);
		}
		catch (UnmanagedException* u)
		{
			Console::WriteLine(S"\nCaught an unmanaged exception\n");
			std::cout << u->Error() << std::endl;
		}
		catch (Exception* e)
		{
			Console::WriteLine(S"\nCaught a managed exception\n");
			Console::WriteLine(e->ToString());
		}
		catch (...)
		{
			Console::WriteLine(S"\nCaught a general exception\n");
		}
	}

	FilterTest();

	return 0;
}
