//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
// COMFault.h : Declaration of the CCOMFault

#pragma once
#include "resource.h"       // main symbols


// ICOMFault
[
	object,
	uuid("FA39498B-3E02-4F00-A385-2DD27DD97BA3"),
	dual,	helpstring("ICOMFault Interface"),
	pointer_default(unique)
]
__interface ICOMFault : IDispatch
{
	[id(1), helpstring("method Fail")] HRESULT Fail(void);
	[id(2), helpstring("method FailWithErrorInfo")] HRESULT FailWithErrorInfo(void);
};



// CCOMFault

[
	coclass,
	threading("both"),
	support_error_info("ICOMFault"),
	vi_progid("COMError.COMFault"),
	progid("COMError.COMFault.1"),
	version(1.0),
	uuid("C4344270-3684-4D51-A739-F921BAF7BC74"),
	helpstring("COMFault Class")
]
class ATL_NO_VTABLE CCOMFault : 
	public ICOMFault
{
public:
	CCOMFault()
	{
		m_pUnkMarshaler = NULL;
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:

	STDMETHOD(Fail)(void);
	STDMETHOD(FailWithErrorInfo)(void);
};

