//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using VBException;
using PerlWordCount;
using CPPExceptions;

namespace CrossLanguage
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class CrossLanguageException
	{
		static void Main(string[] args)
		{
			Console.WriteLine("\nVB exception\n");
			// Throw an exception from VB
			try
			{
				VBExceptionClass vbe = new VBExceptionClass();
				vbe.ExceptionGenerator();
			}
			catch(Exception e)
			{
				Console.WriteLine("Caught a VB exception " + e.ToString());
			}

			Console.WriteLine("\nVC++ exception\n");
			// Throw an exception from VC++
			try
			{
				CPPExceptionClass vcppe = new CPPExceptionClass();
				vcppe.ExceptionGenerator();
			}
			catch(Exception e)
			{
				Console.WriteLine("Caught a VC++ exception " + e.ToString());
			}

			Console.WriteLine("\nPerl exception\n");
			// Now try something from Perl
			using (WordCount obj = new WordCount()) 
			{
				// Set 'Text' property
				obj.Text = "To be or not to be?";

				// Get 'Text' property
				Console.WriteLine("Text is '{0}'", obj.Text);

				// Calling 'Count' for a word not in 'Text' throws an exception
				try 
				{
					String word = "test";
					Console.WriteLine("{0} appears {1} times", word, obj.Count(word));
				}
				catch (Exception e) 
				{
					Console.WriteLine(e.ToString());
				}
			}
		}
	}
}
