//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using PerlWordCount;

class main
{
    public static void Main(string[] args)
    {
        String text = "The quick brown fox jumps over the lazy dog.";

        // Create new 'PerlWordCount.WordCount' object; make sure it gets destroyed too
        using (WordCount obj = new WordCount(text)) {

            // Get 'Text' property
            Console.WriteLine("Text is '{0}'", obj.Text);

            // Set 'Text' property
            obj.Text = "To be or not to be?";

            // 'Count' method without argument returns number of words
            Console.WriteLine("There are {0} distinct words in '{1}'",
                              obj.Count(), obj.Text);

            // 'Words' method returns a 'String[]' array
            // 'Count' method returns number of occurances of word
            foreach (String word in obj.Words())
                Console.WriteLine("{0} appears {1} times", word, obj.Count(word));

            // Calling 'Count' for a word not in 'Text' throws an exception
            try {
                String word = "unknown";
                Console.WriteLine("{0} appears {1} times", word, obj.Count(word));
            }
            catch (Exception e) {
                Console.WriteLine("Exception: {0}", e.Message);
            }
        }
    }
}
