//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Runtime.InteropServices;

namespace UnmanagedException
{
	/// <summary>
	/// Summary description for UnmanagedExceptionTest.
	/// </summary>
	class NativeMethods
	{
		[DllImport("UnmanagedFault.dll")]
		public static extern int Custom();
		[DllImport("UnmanagedFault.dll")]
		public static extern int Fail();
		[DllImport("UnmanagedFault.dll")]
		public static extern int DivideByZero();
		[DllImport("UnmanagedFault.dll")]
		public static extern int MemoryAccess();
		[DllImport("UnmanagedFault.dll")]
		public static extern int Win32Error();
	}
	class UnmanagedExceptionTest
	{
		static void Main(string[] args)
		{
			Console.WriteLine("\nDivide-by-zero\n");
			try
			{
				int result;
				result = NativeMethods.DivideByZero();
			}
			catch(Exception e)
			{
				Console.WriteLine(e.ToString());
			}
			Console.WriteLine("\nMemory Access\n");
			try
			{
				int result;
				result = NativeMethods.MemoryAccess();
			}
			catch(Exception e)
			{
				Console.WriteLine(e.ToString());
			}
			Console.WriteLine("\nFail\n");
			try
			{
				int result;
				result = NativeMethods.Fail();
			}
			catch(Exception e)
			{
				Console.WriteLine(e.ToString());
			}
			Console.WriteLine("\nCustom\n");
			try
			{
				int result;
				result = NativeMethods.Custom();
			}
			catch(Exception e)
			{
				Console.WriteLine(e.ToString());
			}
		}
	}
}
